From fae4bb510b81a3826531cc53357ca6d47efb7715 Mon Sep 17 00:00:00 2001
From: Simon Pichugin <spichugi@redhat.com>
Date: Fri, 18 Nov 2016 10:17:27 +0100
Subject: [PATCH] Ticket 49055 - Add conftest.py for suites

Description: Add all topology fixtures in conftest.py
for all suites and refactor them accordingly.
Fix PEP8 and some logic issues.
Set 2016 date in licenses.
Fix create_test.py according to the new changes plus PEP8.

For now we have:
- topology_st - with topology_st.standalone inst;
- topology_m2 and topology_m4 - with dicts
topology_mN.ms["masterX"]
topology_mN.ms["masterX_agmts"]["mX_mY"]

Using this setup we can easily run through masters
and agreements in loops.

https://fedorahosted.org/389/ticket/49055

Reviewed by: ?
---
 dirsrvtests/create_test.py                         | 890 ++++++++++-----------
 .../acct_usability_plugin/acct_usability_test.py   |  84 --
 .../tests/suites/acctpolicy_plugin/accpol_test.py  | 132 ++-
 .../suites/acctpolicy_plugin/acctpolicy_test.py    |  81 --
 dirsrvtests/tests/suites/acl/acl_test.py           | 862 +++++++++-----------
 .../suites/attr_encryption/attr_encrypt_test.py    |  84 --
 .../attr_uniqueness_plugin/attr_uniqueness_test.py | 152 ++--
 .../suites/automember_plugin/automember_test.py    |  84 --
 dirsrvtests/tests/suites/basic/basic_test.py       | 317 ++++----
 dirsrvtests/tests/suites/betxns/betxn_test.py      | 110 +--
 .../tests/suites/chaining_plugin/chaining_test.py  |  81 --
 dirsrvtests/tests/suites/clu/clu_test.py           |  48 +-
 dirsrvtests/tests/suites/clu/db2ldif_test.py       |  72 --
 .../suites/collation_plugin/collatation_test.py    |  81 --
 dirsrvtests/tests/suites/config/config_test.py     | 245 ++----
 dirsrvtests/tests/suites/conftest.py               | 452 +++++++++++
 dirsrvtests/tests/suites/cos_plugin/cos_test.py    |  81 --
 .../tests/suites/deref_plugin/deref_test.py        |  81 --
 .../suites/disk_monitoring/disk_monitor_test.py    |  81 --
 .../tests/suites/distrib_plugin/distrib_test.py    |  81 --
 dirsrvtests/tests/suites/dna_plugin/dna_test.py    | 123 +--
 dirsrvtests/tests/suites/ds_logs/ds_logs_test.py   |  51 +-
 .../tests/suites/dynamic-plugins/plugin_tests.py   |   2 +-
 .../tests/suites/dynamic-plugins/stress_tests.py   |   2 +-
 .../suites/dynamic-plugins/test_dynamic_plugins.py | 192 ++---
 dirsrvtests/tests/suites/filter/filter_test.py     |  56 +-
 .../suites/filter/rfc3673_all_oper_attrs_test.py   | 122 +--
 .../tests/suites/get_effective_rights/ger_test.py  |  81 --
 .../tests/suites/gssapi_repl/gssapi_repl_test.py   | 129 +--
 dirsrvtests/tests/suites/ldapi/ldapi_test.py       |  81 --
 .../suites/linkedattrs_plugin/linked_attrs_test.py |  81 --
 .../tests/suites/mapping_tree/mapping_tree_test.py |  81 --
 .../tests/suites/memberof_plugin/memberof_test.py  | 138 ++--
 .../tests/suites/memory_leaks/range_search_test.py |  97 +--
 dirsrvtests/tests/suites/monitor/monitor_test.py   |  81 --
 .../suites/paged_results/paged_results_test.py     | 631 +++++++--------
 .../tests/suites/pam_passthru_plugin/pam_test.py   |  81 --
 .../tests/suites/passthru_plugin/passthru_test.py  |  81 --
 dirsrvtests/tests/suites/password/password_test.py |  69 +-
 dirsrvtests/tests/suites/password/pwdAdmin_test.py | 142 ++--
 .../suites/password/pwdPolicy_attribute_test.py    | 216 ++---
 .../password/pwdPolicy_inherit_global_test.py      | 198 ++---
 .../tests/suites/password/pwdPolicy_syntax_test.py |  94 +--
 .../suites/password/pwdPolicy_warning_test.py      | 233 +++---
 dirsrvtests/tests/suites/password/pwd_algo_test.py | 113 +--
 .../tests/suites/password/pwp_history_test.py      | 140 ++--
 .../posix_winsync_plugin/posix_winsync_test.py     |  81 --
 dirsrvtests/tests/suites/psearch/psearch_test.py   |  81 --
 .../tests/suites/referint_plugin/referint_test.py  |  81 --
 .../tests/suites/replication/cleanallruv_test.py   | 683 +++++-----------
 .../replication/wait_for_async_feature_test.py     | 196 ++---
 .../tests/suites/replsync_plugin/repl_sync_test.py |  81 --
 .../suites/resource_limits/res_limits_test.py      |  81 --
 .../tests/suites/retrocl_plugin/retrocl_test.py    |  81 --
 .../tests/suites/reverpwd_plugin/reverpwd_test.py  |  81 --
 .../tests/suites/roles_plugin/roles_test.py        |  81 --
 .../suites/rootdn_plugin/rootdn_plugin_test.py     | 187 ++---
 dirsrvtests/tests/suites/sasl/sasl_test.py         |  81 --
 dirsrvtests/tests/suites/schema/test_schema.py     |  41 +-
 .../schema_reload_plugin/schema_reload_test.py     |  81 --
 dirsrvtests/tests/suites/snmp/snmp_test.py         |  81 --
 dirsrvtests/tests/suites/ssl/ssl_test.py           |  81 --
 .../tests/suites/syntax_plugin/syntax_test.py      |  81 --
 dirsrvtests/tests/suites/usn_plugin/usn_test.py    |  81 --
 .../tests/suites/views_plugin/views_test.py        |  81 --
 dirsrvtests/tests/suites/vlv/vlv_test.py           |  81 --
 .../tests/suites/whoami_plugin/whoami_test.py      |  81 --
 dirsrvtests/tests/tickets/finalizer.py             |   2 +-
 dirsrvtests/tests/tickets/ticket47313_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47384_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47431_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47462_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47490_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47553_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47560_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47573_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47619_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47640_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47653MMR_test.py   |   2 +-
 dirsrvtests/tests/tickets/ticket47653_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47669_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47676_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47714_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47721_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47781_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47787_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47808_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47815_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47819_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47823_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47828_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47829_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47833_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47838_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47869MMR_test.py   |   2 +-
 dirsrvtests/tests/tickets/ticket47871_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47900_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47910_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47920_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47921_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47927_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47937_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47950_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47953_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47963_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47966_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47970_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47973_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47980_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47981_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket47988_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48005_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48026_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48109_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48170_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48226_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48228_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48252_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48265_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48294_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48295_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48366_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48759_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48891_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket48906_test.py      |   2 +-
 dirsrvtests/tests/tickets/ticket548_test.py        |   2 +-
 126 files changed, 3001 insertions(+), 7015 deletions(-)
 delete mode 100644 dirsrvtests/tests/suites/acct_usability_plugin/acct_usability_test.py
 delete mode 100644 dirsrvtests/tests/suites/acctpolicy_plugin/acctpolicy_test.py
 delete mode 100644 dirsrvtests/tests/suites/attr_encryption/attr_encrypt_test.py
 delete mode 100644 dirsrvtests/tests/suites/automember_plugin/automember_test.py
 delete mode 100644 dirsrvtests/tests/suites/chaining_plugin/chaining_test.py
 delete mode 100644 dirsrvtests/tests/suites/clu/db2ldif_test.py
 delete mode 100644 dirsrvtests/tests/suites/collation_plugin/collatation_test.py
 create mode 100644 dirsrvtests/tests/suites/conftest.py
 delete mode 100644 dirsrvtests/tests/suites/cos_plugin/cos_test.py
 delete mode 100644 dirsrvtests/tests/suites/deref_plugin/deref_test.py
 delete mode 100644 dirsrvtests/tests/suites/disk_monitoring/disk_monitor_test.py
 delete mode 100644 dirsrvtests/tests/suites/distrib_plugin/distrib_test.py
 delete mode 100644 dirsrvtests/tests/suites/get_effective_rights/ger_test.py
 delete mode 100644 dirsrvtests/tests/suites/ldapi/ldapi_test.py
 delete mode 100644 dirsrvtests/tests/suites/linkedattrs_plugin/linked_attrs_test.py
 delete mode 100644 dirsrvtests/tests/suites/mapping_tree/mapping_tree_test.py
 delete mode 100644 dirsrvtests/tests/suites/monitor/monitor_test.py
 delete mode 100644 dirsrvtests/tests/suites/pam_passthru_plugin/pam_test.py
 delete mode 100644 dirsrvtests/tests/suites/passthru_plugin/passthru_test.py
 delete mode 100644 dirsrvtests/tests/suites/posix_winsync_plugin/posix_winsync_test.py
 delete mode 100644 dirsrvtests/tests/suites/psearch/psearch_test.py
 delete mode 100644 dirsrvtests/tests/suites/referint_plugin/referint_test.py
 delete mode 100644 dirsrvtests/tests/suites/replsync_plugin/repl_sync_test.py
 delete mode 100644 dirsrvtests/tests/suites/resource_limits/res_limits_test.py
 delete mode 100644 dirsrvtests/tests/suites/retrocl_plugin/retrocl_test.py
 delete mode 100644 dirsrvtests/tests/suites/reverpwd_plugin/reverpwd_test.py
 delete mode 100644 dirsrvtests/tests/suites/roles_plugin/roles_test.py
 delete mode 100644 dirsrvtests/tests/suites/sasl/sasl_test.py
 delete mode 100644 dirsrvtests/tests/suites/schema_reload_plugin/schema_reload_test.py
 delete mode 100644 dirsrvtests/tests/suites/snmp/snmp_test.py
 delete mode 100644 dirsrvtests/tests/suites/ssl/ssl_test.py
 delete mode 100644 dirsrvtests/tests/suites/syntax_plugin/syntax_test.py
 delete mode 100644 dirsrvtests/tests/suites/usn_plugin/usn_test.py
 delete mode 100644 dirsrvtests/tests/suites/views_plugin/views_test.py
 delete mode 100644 dirsrvtests/tests/suites/vlv/vlv_test.py
 delete mode 100644 dirsrvtests/tests/suites/whoami_plugin/whoami_test.py

diff --git a/dirsrvtests/create_test.py b/dirsrvtests/create_test.py
index 3898279..882cf91 100755
--- a/dirsrvtests/create_test.py
+++ b/dirsrvtests/create_test.py
@@ -13,15 +13,16 @@ import optparse
 
 """This script generates a template test script that handles the
 non-interesting parts of a test script:
-- topology,
-- test (to be completed by the user),
-- final,
-- and run-isolated function
+- topology fixture (only for tickets),
+  for suites we have predefined fixtures in the suites/conftest.py
+- test function (to be completed by the user),
+- run-isolated function
 """
 
 
 def displayUsage():
     """Display the usage"""
+
     print ('\nUsage:\ncreate_ticket.py -t|--ticket <ticket number> ' +
            '-s|--suite <suite name> ' +
            '[ i|--instances <number of standalone instances> ' +
@@ -33,6 +34,9 @@ def displayUsage():
            'can add mulitple standalone instances(maximum 10).  However, you' +
            ' can not mix "-i" with the replication options(-m, -h , -c).  ' +
            'There is a maximum of 10 masters, 10 hubs, and 10 consumers.')
+    print('If "-s|--suite" option was chosen, then no topology would be added ' +
+          'to the test script. You can find predefined fixtures in the suites/conftest.py ' +
+          'and usem them or write new one if you have special case.')
     exit(1)
 
 
@@ -41,6 +45,7 @@ def writeFinalizer():
 
     def writeInstanceOp(action):
         """Write instance finializer action"""
+
         if repl_deployment:
             for idx in range(masters):
                 idx += 1
@@ -64,16 +69,15 @@ def writeFinalizer():
                 TEST.write('            standalone' + idx + '.' + action +
                            '()\n')
 
-    TEST.write('    def fin():\n')
-    TEST.write('        """')
-    TEST.write('If we are debugging just stop the instances, ' +
-               'otherwise remove them\n')
-    TEST.write('        """\n')
+    TEST.write('\n    def fin():\n')
+    TEST.write('        """If we are debugging just stop the instances,\n' +
+               '        otherwise remove them\n')
+    TEST.write('        """\n\n')
     TEST.write('        if DEBUGGING:\n')
     writeInstanceOp('stop')
     TEST.write('        else:\n')
     writeInstanceOp('delete')
-    TEST.write('    request.addfinalizer(fin)')
+    TEST.write('\n    request.addfinalizer(fin)')
     TEST.write('\n\n')
 
 
@@ -158,14 +162,11 @@ if len(sys.argv) > 0:
         instances = int(args.inst)
     filename = args.filename
 
-    #
     # Create/open the new test script file
-    #
     if not filename:
         if ticket:
             filename = 'ticket' + ticket + '_test.py'
         else:
-            # suite
             filename = suite + '_test.py'
 
     try:
@@ -174,9 +175,7 @@ if len(sys.argv) > 0:
         print("Can\'t open file:", filename)
         exit(1)
 
-    #
     # Write the imports
-    #
     TEST.write('import os\nimport sys\nimport time\nimport ldap\n' +
                'import logging\nimport pytest\n')
     TEST.write('from lib389 import DirSrv, Entry, tools, tasks\nfrom ' +
@@ -184,306 +183,238 @@ if len(sys.argv) > 0:
                'import *\nfrom lib389.properties import *\n' +
                'from lib389.tasks import *\nfrom lib389.utils import *\n\n')
 
-    #
-    # Set the logger and other settings
-    #
-    TEST.write('DEBUGGING = False\n\n')
-    TEST.write('if DEBUGGING:\n')
-    TEST.write('    logging.getLogger(__name__).setLevel(logging.DEBUG)\n')
-    TEST.write('else:\n')
-    TEST.write('    logging.getLogger(__name__).setLevel(logging.INFO)\n')
-    TEST.write('log = logging.getLogger(__name__)\n\n\n')
-
-    #
-    # Write the replication or standalone classes
-    #
-    repl_deployment = False
-    if masters + hubs + consumers > 0:
-        #
-        # Write the replication class
-        #
-        repl_deployment = True
-
-        TEST.write('class TopologyReplication(object):\n')
-        TEST.write('    """The Replication Topology Class"""\n')
-        TEST.write('    def __init__(self')
-        for idx in range(masters):
-            TEST.write(', master' + str(idx + 1))
-        for idx in range(hubs):
-            TEST.write(', hub' + str(idx + 1))
-        for idx in range(consumers):
-            TEST.write(', consumer' + str(idx + 1))
-        TEST.write('):\n')
-        TEST.write('        """Init"""\n')
-
-        for idx in range(masters):
-            TEST.write('        master' + str(idx + 1) + '.open()\n')
-            TEST.write('        self.master' + str(idx + 1) + ' = master' +
-                       str(idx + 1) + '\n')
-        for idx in range(hubs):
-            TEST.write('        hub' + str(idx + 1) + '.open()\n')
-            TEST.write('        self.hub' + str(idx + 1) + ' = hub' +
-                       str(idx + 1) + '\n')
-        for idx in range(consumers):
-            TEST.write('        consumer' + str(idx + 1) + '.open()\n')
-            TEST.write('        self.consumer' + str(idx + 1) + ' = consumer' +
-                       str(idx + 1) + '\n')
-        TEST.write('\n\n')
-    else:
-        #
-        # Write the standalone class
-        #
-        TEST.write('class TopologyStandalone(object):\n')
-        TEST.write('    """The DS Topology Class"""\n')
-        TEST.write('    def __init__(self')
-        for idx in range(instances):
-            idx += 1
-            if idx == 1:
-                idx = ''
-            else:
-                idx = str(idx)
-            TEST.write(', standalone' + idx)
-        TEST.write('):\n')
-        TEST.write('        """Init"""\n')
-        for idx in range(instances):
-            idx += 1
-            if idx == 1:
-                idx = ''
-            else:
-                idx = str(idx)
-            TEST.write('        standalone' + idx + '.open()\n')
-            TEST.write('        self.standalone' + idx + ' = standalone' +
-                       idx + '\n')
-        TEST.write('\n\n')
-
-    #
-    # Write the 'topology function'
-    #
-    TEST.write('@pytest.fixture(scope="module")\n')
-    TEST.write('def topology(request):\n')
-
-    if repl_deployment:
-        #
-        # Create the replication instances
-        #
-        TEST.write('    """Create Replication Deployment"""\n\n')
-        for idx in range(masters):
-            idx = str(idx + 1)
-            TEST.write('    # Creating master ' + idx + '...\n')
-            TEST.write('    if DEBUGGING:\n')
-            TEST.write('        master' + idx + ' = DirSrv(verbose=True)\n')
-            TEST.write('    else:\n')
-            TEST.write('        master' + idx + ' = DirSrv(verbose=False)\n')
-            TEST.write('    args_instance[SER_HOST] = HOST_MASTER_' + idx +
-                       '\n')
-            TEST.write('    args_instance[SER_PORT] = PORT_MASTER_' + idx +
-                       '\n')
-            TEST.write('    args_instance[SER_SERVERID_PROP] = ' +
-                       'SERVERID_MASTER_' + idx + '\n')
-            TEST.write('    args_instance[SER_CREATION_SUFFIX] = ' +
-                       'DEFAULT_SUFFIX\n')
-            TEST.write('    args_master = args_instance.copy()\n')
-            TEST.write('    master' + idx + '.allocate(args_master)\n')
-            TEST.write('    instance_master' + idx + ' = master' + idx +
-                       '.exists()\n')
-            TEST.write('    if instance_master' + idx + ':\n')
-            TEST.write('        master' + idx + '.delete()\n')
-            TEST.write('    master' + idx + '.create()\n')
-            TEST.write('    master' + idx + '.open()\n')
-            TEST.write('    master' + idx + '.replica.enableReplication' +
-                       '(suffix=SUFFIX, role=REPLICAROLE_MASTER, ' +
-                       'replicaId=REPLICAID_MASTER_' + idx + ')\n\n')
-
-        for idx in range(hubs):
-            idx = str(idx + 1)
-            TEST.write('    # Creating hub ' + idx + '...\n')
-            TEST.write('    if DEBUGGING:\n')
-            TEST.write('        hub' + idx + ' = DirSrv(verbose=True)\n')
-            TEST.write('    else:\n')
-            TEST.write('        hub' + idx + ' = DirSrv(verbose=False)\n')
-            TEST.write('    args_instance[SER_HOST] = HOST_HUB_' + idx + '\n')
-            TEST.write('    args_instance[SER_PORT] = PORT_HUB_' + idx + '\n')
-            TEST.write('    args_instance[SER_SERVERID_PROP] = SERVERID_HUB_' +
-                       idx + '\n')
-            TEST.write('    args_instance[SER_CREATION_SUFFIX] = ' +
-                       'DEFAULT_SUFFIX\n')
-            TEST.write('    args_hub = args_instance.copy()\n')
-            TEST.write('    hub' + idx + '.allocate(args_hub)\n')
-            TEST.write('    instance_hub' + idx + ' = hub' + idx +
-                       '.exists()\n')
-            TEST.write('    if instance_hub' + idx + ':\n')
-            TEST.write('        hub' + idx + '.delete()\n')
-            TEST.write('    hub' + idx + '.create()\n')
-            TEST.write('    hub' + idx + '.open()\n')
-            TEST.write('    hub' + idx + '.replica.enableReplication' +
-                       '(suffix=SUFFIX, role=REPLICAROLE_HUB, ' +
-                       'replicaId=REPLICAID_HUB_' + idx + ')\n\n')
-
-        for idx in range(consumers):
-            idx = str(idx + 1)
-            TEST.write('    # Creating consumer ' + idx + '...\n')
-            TEST.write('    if DEBUGGING:\n')
-            TEST.write('        consumer' + idx + ' = DirSrv(verbose=True)\n')
-            TEST.write('    else:\n')
-            TEST.write('        consumer' + idx + ' = DirSrv(verbose=False)\n')
-            TEST.write('    args_instance[SER_HOST] = HOST_CONSUMER_' + idx +
-                       '\n')
-            TEST.write('    args_instance[SER_PORT] = PORT_CONSUMER_' + idx +
-                       '\n')
-            TEST.write('    args_instance[SER_SERVERID_PROP] = ' +
-                       'SERVERID_CONSUMER_' + idx + '\n')
-            TEST.write('    args_instance[SER_CREATION_SUFFIX] = ' +
-                       'DEFAULT_SUFFIX\n')
-            TEST.write('    args_consumer = args_instance.copy()\n')
-            TEST.write('    consumer' + idx + '.allocate(args_consumer)\n')
-            TEST.write('    instance_consumer' + idx + ' = consumer' + idx +
-                       '.exists()\n')
-            TEST.write('    if instance_consumer' + idx + ':\n')
-            TEST.write('        consumer' + idx + '.delete()\n')
-            TEST.write('    consumer' + idx + '.create()\n')
-            TEST.write('    consumer' + idx + '.open()\n')
-            TEST.write('    consumer' + idx + '.replica.enableReplication' +
-                       '(suffix=SUFFIX, role=REPLICAROLE_CONSUMER, ' +
-                       'replicaId=CONSUMER_REPLICAID)\n\n')
-
-        writeFinalizer()
-
-        #
-        # Create the master agreements
-        #
-        TEST.write('    #\n')
-        TEST.write('    # Create all the agreements\n')
-        TEST.write('    #\n')
-        agmt_count = 0
-        for idx in range(masters):
-            master_idx = idx + 1
+    # Add topology function for a ticket only.
+    # Suites have presetuped fixtures in suites/conftest.py
+    if ticket:
+        TEST.write('DEBUGGING = False\n\n')
+        TEST.write('if DEBUGGING:\n')
+        TEST.write('    logging.getLogger(__name__).setLevel(logging.DEBUG)\n')
+        TEST.write('else:\n')
+        TEST.write('    logging.getLogger(__name__).setLevel(logging.INFO)\n')
+        TEST.write('log = logging.getLogger(__name__)\n\n\n')
+
+        # Write the replication or standalone classes
+        repl_deployment = False
+
+        if masters + hubs + consumers > 0:
+            repl_deployment = True
+
+            TEST.write('class TopologyReplication(object):\n')
+            TEST.write('    def __init__(self')
             for idx in range(masters):
-                #
-                # Create agreements with the other masters (master -> master)
-                #
-                idx += 1
-                if master_idx == idx:
-                    # skip ourselves
-                    continue
-                TEST.write('    # Creating agreement from master ' +
-                           str(master_idx) + ' to master ' + str(idx) + '\n')
-                TEST.write("    properties = {RA_NAME: " +
-                           "'meTo_' + master" + str(idx) +
-                           ".host + ':' + str(master" + str(idx) +
-                           ".port),\n")
-                TEST.write("                  RA_BINDDN: " +
-                           "defaultProperties[REPLICATION_BIND_DN],\n")
-                TEST.write("                  RA_BINDPW: " +
-                           "defaultProperties[REPLICATION_BIND_PW],\n")
-                TEST.write("                  RA_METHOD: " +
-                           "defaultProperties[REPLICATION_BIND_METHOD],\n")
-                TEST.write("                  RA_TRANSPORT_PROT: " +
-                           "defaultProperties[REPLICATION_TRANSPORT]}\n")
-                TEST.write('    m' + str(master_idx) + '_m' + str(idx) +
-                           '_agmt = master' + str(master_idx) +
-                            '.agreement.create(suffix=SUFFIX, host=master' +
-                            str(idx) + '.host, port=master' + str(idx) +
-                            '.port, properties=properties)\n')
-                TEST.write('    if not m' + str(master_idx) + '_m' + str(idx) +
-                           '_agmt:\n')
-                TEST.write('        log.fatal("Fail to create a master -> ' +
-                           'master replica agreement")\n')
-                TEST.write('        sys.exit(1)\n')
-                TEST.write('    log.debug("%s created" % m' + str(master_idx) +
-                           '_m' + str(idx) + '_agmt)\n\n')
-                agmt_count += 1
+                TEST.write(', master' + str(idx + 1))
+            for idx in range(hubs):
+                TEST.write(', hub' + str(idx + 1))
+            for idx in range(consumers):
+                TEST.write(', consumer' + str(idx + 1))
+            TEST.write('):\n')
 
+            for idx in range(masters):
+                TEST.write('        master' + str(idx + 1) + '.open()\n')
+                TEST.write('        self.master' + str(idx + 1) + ' = master' +
+                           str(idx + 1) + '\n')
             for idx in range(hubs):
-                idx += 1
-                #
-                # Create agmts from each master to each hub (master -> hub)
-                #
-                TEST.write('    # Creating agreement from master ' +
-                           str(master_idx) + ' to hub ' + str(idx) + '\n')
-                TEST.write("    properties = {RA_NAME: " +
-                           "'meTo_' + hub" + str(idx) +
-                           ".host + ':' + str(hub" + str(idx) +
-                           ".port),\n")
-                TEST.write("                  RA_BINDDN: " +
-                           "defaultProperties[REPLICATION_BIND_DN],\n")
-                TEST.write("                  RA_BINDPW: " +
-                           "defaultProperties[REPLICATION_BIND_PW],\n")
-                TEST.write("                  RA_METHOD: " +
-                           "defaultProperties[REPLICATION_BIND_METHOD],\n")
-                TEST.write("                  RA_TRANSPORT_PROT: " +
-                           "defaultProperties[REPLICATION_TRANSPORT]}\n")
-                TEST.write('    m' + str(master_idx) + '_h' + str(idx) +
-                           '_agmt = master' + str(master_idx) +
-                           '.agreement.create(suffix=SUFFIX, host=hub' +
-                           str(idx) + '.host, port=hub' + str(idx) +
-                           '.port, properties=properties)\n')
-                TEST.write('    if not m' + str(master_idx) + '_h' + str(idx) +
-                           '_agmt:\n')
-                TEST.write('        log.fatal("Fail to create a master -> ' +
-                           'hub replica agreement")\n')
-                TEST.write('        sys.exit(1)\n')
-                TEST.write('    log.debug("%s created" % m' + str(master_idx) +
-                           '_h' + str(idx) + '_agmt)\n\n')
-                agmt_count += 1
-
-        #
-        # Create the hub agreements
-        #
-        for idx in range(hubs):
-            hub_idx = idx + 1
-            #
-            # Add agreements from each hub to each consumer (hub -> consumer)
-            #
+                TEST.write('        hub' + str(idx + 1) + '.open()\n')
+                TEST.write('        self.hub' + str(idx + 1) + ' = hub' +
+                           str(idx + 1) + '\n')
             for idx in range(consumers):
+                TEST.write('        consumer' + str(idx + 1) + '.open()\n')
+                TEST.write('        self.consumer' + str(idx + 1) + ' = consumer' +
+                           str(idx + 1) + '\n')
+            TEST.write('\n\n')
+        else:
+            TEST.write('class TopologyStandalone(object):\n')
+            TEST.write('    def __init__(self')
+            for idx in range(instances):
                 idx += 1
-                #
-                # Create agreements from each hub to each consumer
-                #
-                TEST.write('    # Creating agreement from hub ' + str(hub_idx)
-                           + ' to consumer ' + str(idx) + '\n')
-                TEST.write("    properties = {RA_NAME: " +
-                           "'meTo_' + consumer" + str(idx) +
-                           ".host + ':' + str(consumer" + str(idx) +
-                           ".port),\n")
-                TEST.write("                  RA_BINDDN: " +
-                           "defaultProperties[REPLICATION_BIND_DN],\n")
-                TEST.write("                  RA_BINDPW: " +
-                           "defaultProperties[REPLICATION_BIND_PW],\n")
-                TEST.write("                  RA_METHOD: " +
-                           "defaultProperties[REPLICATION_BIND_METHOD],\n")
-                TEST.write("                  RA_TRANSPORT_PROT: " +
-                           "defaultProperties[REPLICATION_TRANSPORT]}\n")
-                TEST.write('    h' + str(hub_idx) + '_c' + str(idx) +
-                           '_agmt = hub' + str(hub_idx) +
-                           '.agreement.create(suffix=SUFFIX, host=consumer' +
-                           str(idx) + '.host, port=consumer' + str(idx) +
-                           '.port, properties=properties)\n')
-                TEST.write('    if not h' + str(hub_idx) + '_c' + str(idx) +
-                           '_agmt:\n')
-                TEST.write('        log.fatal("Fail to create a hub -> ' +
-                           'consumer replica agreement")\n')
-                TEST.write('        sys.exit(1)\n')
-                TEST.write('    log.debug("%s created" % h' + str(hub_idx) +
-                           '_c' + str(idx) + '_agmt)\n\n')
-                agmt_count += 1
-
-        if hubs == 0:
-            #
-            # No Hubs, see if there are any consumers to create agreements to
-            #
+                if idx == 1:
+                    idx = ''
+                else:
+                    idx = str(idx)
+                TEST.write(', standalone' + idx)
+            TEST.write('):\n')
+
+            for idx in range(instances):
+                idx += 1
+                if idx == 1:
+                    idx = ''
+                else:
+                    idx = str(idx)
+                TEST.write('        standalone' + idx + '.open()\n')
+                TEST.write('        self.standalone' + idx + ' = standalone' +
+                           idx + '\n')
+            TEST.write('\n\n')
+
+        # Write the 'topology function'
+        TEST.write('@pytest.fixture(scope="module")\n')
+        TEST.write('def topology(request):\n')
+
+        if repl_deployment:
+            TEST.write('    """Create Replication Deployment"""\n')
+            for idx in range(masters):
+                idx = str(idx + 1)
+                TEST.write('\n    # Creating master ' + idx + '...\n')
+                TEST.write('    if DEBUGGING:\n')
+                TEST.write('        master' + idx + ' = DirSrv(verbose=True)\n')
+                TEST.write('    else:\n')
+                TEST.write('        master' + idx + ' = DirSrv(verbose=False)\n')
+                TEST.write('    args_instance[SER_HOST] = HOST_MASTER_' + idx +
+                           '\n')
+                TEST.write('    args_instance[SER_PORT] = PORT_MASTER_' + idx +
+                           '\n')
+                TEST.write('    args_instance[SER_SERVERID_PROP] = ' +
+                           'SERVERID_MASTER_' + idx + '\n')
+                TEST.write('    args_instance[SER_CREATION_SUFFIX] = ' +
+                           'DEFAULT_SUFFIX\n')
+                TEST.write('    args_master = args_instance.copy()\n')
+                TEST.write('    master' + idx + '.allocate(args_master)\n')
+                TEST.write('    instance_master' + idx + ' = master' + idx +
+                           '.exists()\n')
+                TEST.write('    if instance_master' + idx + ':\n')
+                TEST.write('        master' + idx + '.delete()\n')
+                TEST.write('    master' + idx + '.create()\n')
+                TEST.write('    master' + idx + '.open()\n')
+                TEST.write('    master' + idx + '.replica.enableReplication' +
+                           '(suffix=SUFFIX, role=REPLICAROLE_MASTER, ' +
+                           'replicaId=REPLICAID_MASTER_' + idx + ')\n')
+
+            for idx in range(hubs):
+                idx = str(idx + 1)
+                TEST.write('\n    # Creating hub ' + idx + '...\n')
+                TEST.write('    if DEBUGGING:\n')
+                TEST.write('        hub' + idx + ' = DirSrv(verbose=True)\n')
+                TEST.write('    else:\n')
+                TEST.write('        hub' + idx + ' = DirSrv(verbose=False)\n')
+                TEST.write('    args_instance[SER_HOST] = HOST_HUB_' + idx + '\n')
+                TEST.write('    args_instance[SER_PORT] = PORT_HUB_' + idx + '\n')
+                TEST.write('    args_instance[SER_SERVERID_PROP] = SERVERID_HUB_' +
+                           idx + '\n')
+                TEST.write('    args_instance[SER_CREATION_SUFFIX] = ' +
+                           'DEFAULT_SUFFIX\n')
+                TEST.write('    args_hub = args_instance.copy()\n')
+                TEST.write('    hub' + idx + '.allocate(args_hub)\n')
+                TEST.write('    instance_hub' + idx + ' = hub' + idx +
+                           '.exists()\n')
+                TEST.write('    if instance_hub' + idx + ':\n')
+                TEST.write('        hub' + idx + '.delete()\n')
+                TEST.write('    hub' + idx + '.create()\n')
+                TEST.write('    hub' + idx + '.open()\n')
+                TEST.write('    hub' + idx + '.replica.enableReplication' +
+                           '(suffix=SUFFIX, role=REPLICAROLE_HUB, ' +
+                           'replicaId=REPLICAID_HUB_' + idx + ')\n')
+
+            for idx in range(consumers):
+                idx = str(idx + 1)
+                TEST.write('\n    # Creating consumer ' + idx + '...\n')
+                TEST.write('    if DEBUGGING:\n')
+                TEST.write('        consumer' + idx + ' = DirSrv(verbose=True)\n')
+                TEST.write('    else:\n')
+                TEST.write('        consumer' + idx + ' = DirSrv(verbose=False)\n')
+                TEST.write('    args_instance[SER_HOST] = HOST_CONSUMER_' + idx +
+                           '\n')
+                TEST.write('    args_instance[SER_PORT] = PORT_CONSUMER_' + idx +
+                           '\n')
+                TEST.write('    args_instance[SER_SERVERID_PROP] = ' +
+                           'SERVERID_CONSUMER_' + idx + '\n')
+                TEST.write('    args_instance[SER_CREATION_SUFFIX] = ' +
+                           'DEFAULT_SUFFIX\n')
+                TEST.write('    args_consumer = args_instance.copy()\n')
+                TEST.write('    consumer' + idx + '.allocate(args_consumer)\n')
+                TEST.write('    instance_consumer' + idx + ' = consumer' + idx +
+                           '.exists()\n')
+                TEST.write('    if instance_consumer' + idx + ':\n')
+                TEST.write('        consumer' + idx + '.delete()\n')
+                TEST.write('    consumer' + idx + '.create()\n')
+                TEST.write('    consumer' + idx + '.open()\n')
+                TEST.write('    consumer' + idx + '.replica.enableReplication' +
+                           '(suffix=SUFFIX, role=REPLICAROLE_CONSUMER, ' +
+                           'replicaId=CONSUMER_REPLICAID)\n')
+
+            writeFinalizer()
+
+            # Create the master agreements
+            TEST.write('    # Create all the agreements\n')
+            agmt_count = 0
+
             for idx in range(masters):
                 master_idx = idx + 1
-                #
-                # Create agreements with the consumers (master -> consumer)
-                #
+
+                # Create agreements with the other masters (master -> master)
+                for idx in range(masters):
+                    idx += 1
+
+                    # Skip ourselves
+                    if master_idx == idx:
+                        continue
+
+                    TEST.write('\n    # Creating agreement from master ' +
+                               str(master_idx) + ' to master ' + str(idx) + '\n')
+                    TEST.write("    properties = {RA_NAME: " +
+                               "'meTo_' + master" + str(idx) +
+                               ".host + ':' + str(master" + str(idx) +
+                               ".port),\n")
+                    TEST.write("                  RA_BINDDN: " +
+                               "defaultProperties[REPLICATION_BIND_DN],\n")
+                    TEST.write("                  RA_BINDPW: " +
+                               "defaultProperties[REPLICATION_BIND_PW],\n")
+                    TEST.write("                  RA_METHOD: " +
+                               "defaultProperties[REPLICATION_BIND_METHOD],\n")
+                    TEST.write("                  RA_TRANSPORT_PROT: " +
+                               "defaultProperties[REPLICATION_TRANSPORT]}\n")
+                    TEST.write('    m' + str(master_idx) + '_m' + str(idx) +
+                               '_agmt = master' + str(master_idx) +
+                                '.agreement.create(suffix=SUFFIX, host=master' +
+                                str(idx) + '.host, port=master' + str(idx) +
+                                '.port, properties=properties)\n')
+                    TEST.write('    if not m' + str(master_idx) + '_m' + str(idx) +
+                               '_agmt:\n')
+                    TEST.write('        log.fatal("Fail to create a master -> ' +
+                               'master replica agreement")\n')
+                    TEST.write('        sys.exit(1)\n')
+                    TEST.write('    log.debug("%s created" % m' + str(master_idx) +
+                               '_m' + str(idx) + '_agmt)\n')
+                    agmt_count += 1
+
+                # Create agmts from each master to each hub (master -> hub)
+                for idx in range(hubs):
+                    idx += 1
+                    TEST.write('\n    # Creating agreement from master ' +
+                               str(master_idx) + ' to hub ' + str(idx) + '\n')
+                    TEST.write("    properties = {RA_NAME: " +
+                               "'meTo_' + hub" + str(idx) +
+                               ".host + ':' + str(hub" + str(idx) +
+                               ".port),\n")
+                    TEST.write("                  RA_BINDDN: " +
+                               "defaultProperties[REPLICATION_BIND_DN],\n")
+                    TEST.write("                  RA_BINDPW: " +
+                               "defaultProperties[REPLICATION_BIND_PW],\n")
+                    TEST.write("                  RA_METHOD: " +
+                               "defaultProperties[REPLICATION_BIND_METHOD],\n")
+                    TEST.write("                  RA_TRANSPORT_PROT: " +
+                               "defaultProperties[REPLICATION_TRANSPORT]}\n")
+                    TEST.write('    m' + str(master_idx) + '_h' + str(idx) +
+                               '_agmt = master' + str(master_idx) +
+                               '.agreement.create(suffix=SUFFIX, host=hub' +
+                               str(idx) + '.host, port=hub' + str(idx) +
+                               '.port, properties=properties)\n')
+                    TEST.write('    if not m' + str(master_idx) + '_h' + str(idx) +
+                               '_agmt:\n')
+                    TEST.write('        log.fatal("Fail to create a master -> ' +
+                               'hub replica agreement")\n')
+                    TEST.write('        sys.exit(1)\n')
+                    TEST.write('    log.debug("%s created" % m' + str(master_idx) +
+                               '_h' + str(idx) + '_agmt)\n')
+                    agmt_count += 1
+
+            # Create the hub agreements
+            for idx in range(hubs):
+                hub_idx = idx + 1
+
+                # Add agreements from each hub to each consumer (hub -> consumer)
                 for idx in range(consumers):
                     idx += 1
-                    #
-                    # Create agreements from each master to each consumer
-                    #
-                    TEST.write('    # Creating agreement from master ' +
-                               str(master_idx) + ' to consumer ' + str(idx) +
-                               '\n')
+                    TEST.write('\n    # Creating agreement from hub ' + str(hub_idx)
+                               + ' to consumer ' + str(idx) + '\n')
                     TEST.write("    properties = {RA_NAME: " +
                                "'meTo_' + consumer" + str(idx) +
                                ".host + ':' + str(consumer" + str(idx) +
